#!/usr/bin/perl
# parse linux-sound.org 

my $debug=0;
$dstdir="/tmp/wiki/all/";

#
#
my $prog = 0;
my @software;
my @pgc= ( '/', '-' ,'\\' ,'|' );
$|=1;

print "re-wrting wiki files: $dstdir/*\n";
print " - merging tags..\n";

opendir (DIR, $dstdir);
while (defined($file = readdir(DIR))) {
	next unless $file =~ m/.txt$/;	
#	next if $file =~ m/^start.txt$/;	
#	next if $file =~ m/^index.txt$/;	
	mergetags($dstdir."/".$file);
}
if (!$debug) { print "\n"; }


sub mergetags ($) {
	$outfile=shift;
	if ($debug) {
		print $outfile,"\n";
	} else {
		printf ("\r %s %i ",$pgc[($prog%4)],$prog++);
	}

	open( SFH, "+< $outfile");
	my @lines = <SFH>;
	my %seen = ();
	my $desc = "";
	my $topic = "";
	my $link = "";
	my $title = "";
	my %tags = ();
	truncate SFH, 0;
	seek SFH,0,0;

	foreach (grep(/======/,@lines)) {
		print SFH $_;
		$title=$_;
		$title =~ s/==+//g;
		$title =~ s/[ ]+/ /g;
		chomp $title;
	}
	print SFH "{{metacard>}}\n";

	foreach (sort grep { ! $seen{$_} ++ } @lines) {
		next if $_ =~ m/======/;
		if ($_ =~ m/^{{tag>(.*)}}$/ ) {
			foreach (split " ", "$1") {
				$tags{$_} ++;
			}
#		} elsif ($_ =~ m/^~~META:topic=>(.*)~~$/ ) {
#			if  ($topic eq "" || $_ != "new") {$topic = $_; }
		} else {
			# TODO parse $desc. max 99 chars of plain text?!
			print SFH $_;
			if ($_ =~ m/([fht]+tp:\/\/[^\s]*)/ ) { $link=$1; }
			next if ($_ =~ m/^~~META:/);
			if ($_ =~ m/^[^\s]/ ) { chomp($desc.=$_); }
		}
	}

	my $tagstring =  join ' ' , sort keys %tags;
	if ($tagstring) {
		print SFH "{{tag>".$tagstring."}}\n";
	}
	$desc =~ s/[\\\*\/\[\]\|]//g;
	if (length($desc) > 99) {
		$desc=substr($desc,0,97)."..";
	}

	print SFH "~~META:title=".$title."~~\n";
	print SFH "~~META:desc=".$desc."~~\n";
#	print SFH "~~META:topic=".$topic."~~\n";
	print SFH "~~META:logo=~~\n";
	print SFH "~~META:link=".$link."~~\n";
	print SFH "~~META:screenshot=~~\n";
	print SFH "~~META:banner=~~\n";
	print SFH "~~META:author=~~\n";
	print SFH "~~META:download=~~\n";
	print SFH "~~META:version=~~\n";
	print SFH "~~META:forum=~~\n";
	print SFH "~~META:manual=~~\n";
	print SFH "~~META:example=~~\n";
	close(SFH);
}
